extends KinematicBody2D

export(Vector2) var speed

onready var anim = get_node("AnimationPlayer")
onready var cooldown = get_node("CooldownTimer")
onready var targetingArea = get_node("TargetingArea")

func _ready():
	set_process(true)

func _process(delta):
	var targets = targetingArea.get_overlapping_bodies()
	if targets.size() > 0:
		attack()
	else:
		walk(speed * delta)

func attack():
	if not anim.is_playing() or anim.get_current_animation() != "attack":
		anim.play("attack")

func deal_damage():
	var targets = targetingArea.get_overlapping_bodies()
	for target in targets:
		if target.has_method("receive_damage"):
			target.receive_damage(1)

func walk(distance):
	if not anim.is_playing() or anim.get_current_animation() != "walk":
		anim.play("walk")
	move(distance)
