extends Sprite

export(Vector2) var speed = Vector2(100,0)

onready var targetingArea = get_node("TargetingArea")
onready var cooldownTimer = get_node("CooldownTimer")

func _ready():
	set_process(true)

func _process(delta):
	translate(speed * delta)

func _on_TargetingArea_body_enter( body ):
	set_process(false)
	attack()

func _on_TargetingArea_body_exit( body ):
	set_process(true)

func attack():
	var targets = targetingArea.get_overlapping_bodies()
	for target in targets:
		if target.has_method("receive_damage"):
			target.receive_damage(1)
	
	if targets.size() > 0:
		cooldownTimer.start()
		yield(cooldownTimer, "timeout")
		attack()

